#![allow(unused, reason = "Temporary.")]
//! goal is a custom ui/menu library that allows simple and declarative menus.
//! bevy ui is annoying.

use std::marker::PhantomData;

use bevy::{platform::collections::HashMap, prelude::*};

type ToDo = ();

#[derive(Debug)]
pub struct Menus<NavState: States> {
    menus: HashMap<NavState, Menu<NavState>>,
}

#[derive(Debug)]
pub struct Menu<ParentNavState: States> {
    menu_items: Vec<MenuItemInternal<ParentNavState>>,
}

pub use item::types::*;
pub use item::*;

mod item;

impl<NavState: States> Menus<NavState> {
    pub fn new() -> Self {
        Self {
            menus: HashMap::new(),
        }
    }

    pub fn add_menu(mut self, state: NavState, menu: Menu<NavState>) -> Self {
        self.menus.insert(state, menu);
        self
    }
}

impl<ParentNavState: States> Menu<ParentNavState> {
    pub fn new() -> Self {
        Self {
            menu_items: Vec::new(),
        }
    }

    /// Adds `items` in the default `ItemPosition::MainView`.
    pub fn add_items(mut self, items: &[&dyn MenuItem<ParentNavState>]) -> Self {
        self.add_items_positioned(ItemPosition::MainView, items)
    }

    pub fn add_items_positioned(
        mut self,
        position: ItemPosition,
        items: &[&dyn MenuItem<ParentNavState>],
    ) -> Self {
        items
            .iter()
            .map(|it| (*it).item())
            .collect_into(&mut self.menu_items);
        self
    }
}
