use bevy::state::state::States;

use crate::menus::lib::ToDo;

/// positions the item in the menu
#[derive(Default, Debug)]
pub enum ItemPosition {
    #[default]
    MainView,
    North,
    NorthWest,
    West,
    SouthWest,
    South,
    SouthEast,
    East,
    NorthEast,
}

// TODO: replace strings with custom "content"?
#[derive(Clone, Debug)]
pub enum MenuItemType {
    Text(String),
    Button(String),
    Subsection(Vec<MenuItemType>),
}

#[derive(Clone, Debug)]
pub enum OnPressAction<NavState: States> {
    NavigateTo(NavState),
    RunSystem(ToDo),
    SampleAction,
}
